import { HttpApi } from '@aws-cdk/aws-apigatewayv2-alpha';
import { RestApi } from 'aws-cdk-lib/aws-apigateway';
import { RetentionDays } from 'aws-cdk-lib/aws-logs';
import { Construct } from 'constructs';
import { EvalEngine } from '.';
export interface ApiProps {
    readonly evalEngine: EvalEngine;
    readonly accessLogRetention?: RetentionDays;
}
export declare class Api extends Construct {
    readonly awsApiGatewayRestApi: RestApi;
    readonly awsApiGatewayHTTPApi: HttpApi;
    readonly accessLogRetention: RetentionDays;
    constructor(scope: Construct, id: string, props: ApiProps);
    get externalBaseUrl(): string;
}
